// create angular app
var validationApp = angular.module('validationApp', []);

var INTEGER_REGEXP = /^\-?\d+$/;
validationApp.directive('integer', function() {
	return {
		require : 'ngModel',
		link : function(scope, elm, attrs, ctrl) {
			ctrl.$parsers.unshift(function(viewValue) {
				if (INTEGER_REGEXP.test(viewValue)) {
					// it is valid
					console.log("Good");
					ctrl.$setValidity('integer', true);
					return viewValue;

				} else {
					console.log("Bad");
					// it is invalid, return undefined (no model update)
					ctrl.$setValidity('integer', false);
					return undefined;
				}
			});
		}
	};
});

// create angular controller
validationApp.controller('mainController', function($scope, $window, $http) {

	$scope.urlParam = function(name) {
		var results = new RegExp('[\\?&]' + name + '=([^&#]*)')
				.exec(window.location.href);
		if (!results) {
			return 0;
		}
		return results[1] || 0;
	}
	$scope.callbackURL = $scope.urlParam("ippInteractionUri");
	var newTemp = $scope.callbackURL.replace(/:/g, "\\:");
	$scope.callbackURL = newTemp;
	$scope.user = {};
	newTemp = $scope.callbackURL.split('l/');
	$scope.callbackURL = newTemp[1];
	$http.get($scope.callbackURL + '/inData/UserName').success(
			function(data) {
				var converter = new X2JS({
					skipEmptyTextNodesForObj : true,
					emptyNodeForm : 'text',
					enableToStringFunc : false,
				// this config param informs x2js to create arrays for below paths

				});
				$scope.user = converter.xml_str2json(data).Data;

				angular.forEach($scope.user, function(obj, key) {
					if (angular.isObject(obj) && obj.__text !== undefined
							&& obj._xmlns !== undefined && obj._xmlns === '') {
						if (obj.__text !== '') {
							// found a primitive;
							// delete the object
							delete this[key];
							this[key] = obj.__text;
							//                                           console.log("Deleted key: " + key);
						} else {
							// it means found empty string
							delete this[key];
							this[key] = "";
						}
					}
				}, $scope.user); // end 2nd level object.                                        

				console.log($scope.user);
			}).error(function(err, status) {
		console.log(err);
	})

	// function to submit the form after all validation has occurred			
	$scope.submitForm = function() {
		/*$scope.callbackURL = $scope.urlParam("ippInteractionUri");
		var newTemp = $scope.callbackURL.replace(/:/g, "\\:");
		$scope.callbackURL = newTemp;
		newTemp = $scope.callbackURL.split('l/');
		$scope.callbackURL = newTemp[1];*/

		//var interaction = window.bpm.portal.Interaction.bind();
		$scope.submitted = true;
		//interaction.saveData();
		var converter = new X2JS();
		//var interactionProvider = new bpm.portal.Interaction();
		var username = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><UserName>"
				+ converter.json2xml_str($scope.user) + "</UserName>";
		/*interactionProvider.saveData(null,$scope.user, function() {
			alert('saved data');
		});
		 */
		// check to make sure the form is completely valid
		/*$http.put($scope.callbackURL+'/outData/UserName', username, {headers:{'Content-Type':'application/xml; charset=UTF-8'}}).success(function(data){
			console.log(data);
		}).error(function(err, status){
			
			console.log(err);
		})*/
		if ($scope.userForm.$valid) {
			$window.alert('Our form is amazing');
			$http.put($scope.callbackURL + '/outData/UserName', username, {
				headers : {
					'Content-Type' : 'application/xml; charset=UTF-8'
				}
			}).success(function(data) {
				console.log(data);
			}).error(function(err, status) {

				console.log(err);
			})
			return true;
		} else {
			$window.alert("Form has error, please fix those.");
			return false;
		}

	};

});